<template>
  <div class="filter">
    <div v-if="selectType === drawableFilterType.Zoom" class="filter-zoom">
      <vue-slider
        v-model="zoom"
        :min="1"
        :max="2"
        :interval="0.01"
        :silent="true"
        :dotStyle="dotStyle"
        :railStyle="railStyle"
        :processStyle="processStyle"
        @change="onChangeZoom"
      ></vue-slider>
    </div>
    <div v-if="selectType === drawableFilterType.Contrast" class="filter-contrast">
      <vue-slider
        v-model="contrast"
        :interval="0.001"
        :min="-1"
        :max="1"
        :silent="true"
        :dotStyle="dotStyle"
        :railStyle="railStyle"
        :processStyle="processStyle"
        @drag-end="onChangeContrast"
      ></vue-slider>
    </div>
    <div v-if="selectType === drawableFilterType.Color" class="filter-color">
      <button class="white" @click="$emit('color', 'white')">Trắng</button>
      <button class="black" @click="$emit('color', 'black')">Đen</button>
    </div>
    <div class="filter-btns">
      <button
        :class="selectType === drawableFilterType.Zoom ? 'active' : ''"
        @click="onSelectFilterType(drawableFilterType.Zoom)"
      >
        <font-awesome-icon icon="crop" />
        <span>Crop</span>
      </button>
      <button
        :class="selectType === drawableFilterType.Contrast ? 'active' : ''"
        @click="onSelectFilterType(drawableFilterType.Contrast)"
      >
        <font-awesome-icon icon="adjust" />
        <span>Tương phản</span>
      </button>
      <button
        :class="selectType === drawableFilterType.Color ? 'active' : ''"
        @click="onSelectFilterType(drawableFilterType.Color)"
      >
        <font-awesome-icon icon="tint" />
        <span>Màu</span>
      </button>
    </div>
  </div>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';

enum DrawableFilterType {
  None = 0,
  Contrast = 1,
  Color = 2,
  Zoom = 3
}

@Component
export default class DrawableFilterComponent extends Vue {
  drawableFilterType = DrawableFilterType;
  selectType: number = DrawableFilterType.None;
  contrast: number = 0;
  zoom: number = 1;
  dotStyle = { backgroundColor: '#f88f00', border: '2px solid white' };
  railStyle = { height: '2px' };
  processStyle = { backgroundColor: '#f88f00' };

  onChangeZoom() {
    this.$emit('zoom', this.zoom);
  }

  onChangeContrast() {
    this.$emit('contrast', this.contrast);
  }

  onSelectFilterType(type: DrawableFilterType) {
    this.selectType = this.selectType === type ? DrawableFilterType.None : type;
  }
}
</script>

<style lang="scss" scoped>
.filter {
  width: 80%;
  margin: 0 auto;
  margin-top: 1vh;

  .filter-btns {
    display: flex;
    flex-direction: row;
    justify-content: center;
    align-items: center;

    button {
      background-color: transparent;
      border: none;
      font-size: 2vh;
      font-weight: bold;
      padding: 10px;
      font-family: 'Montserrat', san-serif;
      outline: none;
      display: flex;
      flex-direction: column;
      align-items: center;
      justify-content: center;
      color: white;
      margin: 1.5vh;

      &.active {
        color: $primary;
      }

      svg {
        height: 4vh;
        margin-bottom: 2vh;
      }
    }
  }

  .filter-color {
    button {
      padding: 1.5vw 3vw;
      border-radius: 1vh;
      font-size: 3vw;
      outline: none;

      &.white {
        border: 1px solid black;
        color: black;
        background-color: white;
      }

      &.black {
        border: 1px solid white;
        color: white;
        background-color: black;
      }
    }
  }

  .filter-zoom,
  .filter-contrast {
    padding: 0 15px;
  }
}

@include Orientation(Landscape) {
  .filter {
    margin-top: 0;

    .filter-btns {
      button {
        padding: 1.5vh 3vh;
        font-size: 3vh;

        svg {
          height: 2.5vw;
        }
      }
    }

    .filter-color {
      button {
        padding: 1.5vh 3vh;
        font-size: 3vh;
      }
    }
  }
}
</style>